from tkinter import *
import random,math,time
def array(N1, N2=0,N3=0,init=0):   #■配列宣言
    if N2==0: return [init for i in range(N1)]
    if N3==0: return [[init for i in range(N2)]
                      for j in range(N1)]
    return[[[init for i in range(N3)]for j in range(N2)]
           for k in range(N1)]
random.seed(12345) # 完全に乱数にするには, この行をコメントに
NUM=3  # 巣の数
NFLY=5 # Levy flightの回数
Pa=0.5 # 巣から卵が捨てられる確率
nest=array(NUM,2)
for i in range(NUM):#■初期設定
    nest[i][0]=random.random()*10
    nest[i][1]=random.random()*10
def Levy():#■レヴィー分布
    x=random.random()*10  # レヴィー分布のときの分布係数=10
    if abs(x)<0.00001:return 0
    c=0.5
    A=math.sqrt(c/(2*math.pi))
    return A*math.exp(-c/(2*x))/(math.pow(x,1.5))
def LevyFlight(x, y,Pace=0.001):#Levy flight
    th=random.random()*2.0*math.pi
    DH=Levy()*Pace*5 #Levy Flight
    #DH=Pace         #Isotropic Random Walk
    return [x+DH*math.cos(th),y+DH*math.sin(th)]
def fitV(X):         #■適合度計算
    X1=X[0]-1;X2=X[0]-4;X3=X[0]-7;X4=X[0]-9
    Y1=X[1]-9;Y2=X[1]-4;Y3=X[1]-5;Y4=X[1]-1
    return X1*X2*X3*X4+Y1*Y2*Y3*Y4+158
def repeatLevyFlight(X):#■レヴィー移動を繰り返す
    global NFLY
    X2=array(2); X2[0]=X[0];X2[1]=X[1];F=1E32
    for i in range(NFLY):
        F2=fitV(X2)
        while F2<F:
            F=F2;X2=LevyFlight(X2[0],X2[1]);F2=fitV(X2)
    return [F,X2]
def abandonNest(minI):#■卵が巣から捨てられる処理
    global NUM,nest,Pa
    for i in range(NUM):
        if i!=minI:
            if random.random()<Pa:
                nest[i][0]=random.random()*10
                nest[i][1]=random.random()*10
#--------------以下画像表示----------------
def cCode(V):        #■RBG値チェック
    if V<0:return 0
    if V>255: return 255
    return int(V)
def setColor(V,av, dV):     #■色コード設定
    if V>=av: DC=(V-av)/dV; R=2*DC;G=255-DC;B=0
    else:R=0; DC=(av-V)/dV; G=255-DC/2;B=DC/2
    return "#%02X%02X%02X"%(cCode(R),cCode(G),cCode(B))
def colorMap(canvas):#■適合度による色地図表示
    mn=1E32;mx=-1E32;xy=array(2)
    for i in range(101):#最大・最小を求める
        xy[1]=0
        for j in range(101):
            V=fitV(xy)
            if V<mn: mn=V
            if V>mx: mx=V
            xy[1]+=0.1
        xy[0]+=0.1
    av=(mx+mn)/2; dV=(mx-av)/255;X0=0
    xy[0]=0
    for i in range(101):
        XX=xy[0]*20+20; xy[1]=0 #Y0=0;xy[0]=X0
        for j in range(101):
            #xy[1]=Y0;
            YY=xy[1]*20+20;V=fitV(xy)
            CL=setColor(V,av,dV)
            canvas.create_rectangle(XX,YY,XX+2,YY+2,
                                    fill=CL,outline="")
            xy[1]+=0.1
        xy[0]+=0.1
def dspNest(canvas,nest,minI):#■巣の位置の表示
    canvas.delete("DT")
    for i in range(len(nest)):
        X=nest[i][0]*20+20; Y=nest[i][1]*20+20
        CL="white"
        if i==minI:CL="red"
        canvas.create_rectangle(X-3,Y-3,X+3,Y+3,
                                fill=CL, tag="DT")
#--------以下, メイン・プログラム-------------------
root=Tk();root.title("Cuckoo Search")
canvas=Canvas(root,width=240,height=240,bg="white")
canvas.pack();colorMap(canvas);root.update()
minF=1E30;minI=-999
for k in range(500):
    dspNest(canvas,nest,minI)
    root.update()
    i=int(random.random()*NUM) # i番目Levy flight
    R=repeatLevyFlight(nest[i])
    F2=R[0];nest[i][0]=R[1][0];nest[i][1]=R[1][1];
    if F2<minF:minI=i;minF=F2  # 
    j=int(random.random()*NUM); F=fitV(nest[j])
    if F<minF: minI=j;minF=F
    abandonNest(minI) #卵が巣から捨てられる処理
    i=minI;R=repeatLevyFlight(nest[i])
    F2=R[0];nest[i][0]=R[1][0];nest[i][1]=R[1][1];
    if F2<minF:minF=F2
    time.sleep(0.001)
print(minI,minF,nest[minI])
